<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:c="http://java.sun.com/jstl/core"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml">
    <s:div id="#{analysisBeanGui.id}ResultPanel" rendered="#{analysisBeanGui.getSelectedObject() != null}">

        <ui:decorate template="/layout/panels/_panel_title_id.xhtml">

            <ui:param name="panel_id" value="#{analysisBeanGui.id}GeneralTreePanel"/>

            <ui:define name="panel_title">
                <h:outputText value="#{messages['net.ihe.gazelle.evs.FileDescription']}"/>
            </ui:define>

            <div class="split-panel horizontal">
                <div>
                    <a4j:region>
                        <rich:tree id="#{analysisBeanGui.id}TreeOfParams" value="#{analysisBeanGui.buildTree()}" var="node"
                                   style="vertical-align:top"
                                   rowKeyConverter="org.richfaces.IntegerSequenceRowKeyConverter"
                                   adviseNodeOpened="#{analysisBeanGui.adviseNodeOpened}"
                                   adviseNodeSelected="#{analysisBeanGui.adviseNodeSelected}"
                                   selectionType="client" execute="@this" render="#{analysisBeanGui.id}PanelPartArea" toggleType="client">
                            <rich:treeNode expanded="#{true}">

                                <s:span title="#{messages['net.ihe.gazelle.mca.NoNamespaceIsDefinedForThisTagSoWeCouldntLinkItT']}"
                                        rendered="#{node.data.noDefinedNamespace}" styleClass="gzl-icon-exclamation-triangle"/>

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.evs.ViewPart']}"
                                        ignoreDupResponses="true"
                                        action="#{analysisBeanGui.setMessagePart(analysisBeanGui.selectedObject.object.filePath, node.data)}"
                                        render="#{analysisBeanGui.id}PanelPartArea"
                                        rendered="#{analysisBeanGui.isDisplayablePart(node.data)}">
                                    <h:outputText value="#{node.data.docType}"/>
                                    <s:span styleClass="gzl-icon-eye"/>
                                </a4j:commandLink>
                                <s:span rendered="#{not analysisBeanGui.isDisplayablePart(node.data)}">
                                    <h:outputText value="#{node.data.docType}"/>
                                </s:span>

                                <h:outputLink
                                        value="#{analysisBeanGui.getValidationPermanentLinkFromDb(node.data.oid)}"
                                        target="_blank"
                                        rendered="#{analysisBeanGui.getValidationPermanentLinkFromDb(node.data.oid) != 'not performed'}">
                                    <s:span title="#{messages['gazelle.evs.ClickToViewValidationOutcome']}" styleClass="#{analysisBeanGui.getIconForNode(node.data)}"/>
                                </h:outputLink>

                                <a4j:commandLink
                                        action="#{analysisBeanGui.validate(node.data)}"
                                        target="_blank"
                                        execute="resultFormTokenId"
                                        rendered="#{node.data.validationType!=null and not empty node.data.validationType}">
                                    <s:span title="#{messages['net.ihe.gazelle.xval.Validate']}" styleClass="gzl-icon-play"/>
                                </a4j:commandLink>

                                <a4j:commandLink
                                        action="#{analysisBeanGui.validate(node.data)}"
                                        target="_blank"
                                        execute="resultFormTokenId"
                                        rendered="#{empty node.data.validationType and analysisBeanGui.isValidable(node.data)}">
                                    <span class="gzl-icon-stack" title="#{messages['net.ihe.gazelle.xval.Validate']}">
                                        <em class="gzl-icon-play gzl-icon-stack-1x gzl-icon-stack-up "/>
                                        <em class="gzl-icon-question-circle gzl-icon-stack-1x gzl-icon-stack-small-bottom-right"/>
                                    </span>
                                </a4j:commandLink>

                                <!-- XVal -->
                                <s:span rendered="#{node.data.xValMatch.xValidatorOid != null and not empty node.data.xValMatch.xValidatorOid}">
                                    <s:span rendered="#{analysisBeanGui.getCrossValidationPermanentLink(node.data.oid) != null}">
                                        <h:outputLink
                                                value="#{analysisBeanGui.getCrossValidationPermanentLink(node.data.oid)}"
                                                target="_blank">
                                            <s:span title="#{messages['net.ihe.gazelle.mca.ClickToViewCrossValidationOutcome']}" styleClass="#{analysisBeanGui.getIconForXNode(node.data.oid)}"/>
                                        </h:outputLink>
                                    </s:span>
                                    <s:span rendered="#{analysisBeanGui.crossValidatorAvailable(node.data.xValidatorOid)}">
                                            <h:commandLink actionListener="#{analysisBeanGui.sendToXValidation(node.data)}">
                                                <span class="gzl-icon-stack" title="#{messages['net.ihe.gazelle.mca.SendToCrossValidation']}">
                                                    <em class="gzl-icon-play gzl-icon-stack-1x gzl-icon-stack-up "/>
                                                    <em class="gzl-icon-times-blue gzl-icon-stack-1x gzl-icon-stack-small-bottom-right"/>
                                                </span>
                                            </h:commandLink>
                                    </s:span>
                                    <s:span rendered="#{not analysisBeanGui.crossValidatorAvailable(node.data.xValidatorOid)}">
                                            <s:span styleClass="gzl-icon-stack" title="#{messages['net.ihe.gazelle.mca.CrossValidatorNotAvailable']}">
                                                <em style="color:C6C6C6" class="gzl-icon-play gzl-icon-stack-1x gzl-icon-stack-up "/>
                                                <em style="color:C6C6C6" class="gzl-icon-times-blue gzl-icon-stack-1x gzl-icon-stack-small-bottom-right"/>
                                            </s:span>
                                    </s:span>
                                </s:span>

                                <h:commandLink
                                        title="#{messages['net.ihe.gazelle.evs.DownloadPart']}"
                                        ignoreDupResponses="true"
                                        action="#{analysisBeanGui.downloadFile(analysisBeanGui.selectedObject.object.filePath, node.data, false)}"
                                        rendered="#{analysisBeanGui.getNameSpaces().isEmpty() and analysisBeanGui.isDownloadable(node.data)}">
                                    <s:span title="#{messages['net.ihe.gazelle.xval.Download']}" styleClass="gzl-icon-download"/>
                                </h:commandLink>

                                <s:div rendered="#{!analysisBeanGui.getNameSpaces().isEmpty()}" style="display: inline">

                                    <a title="#{messages['net.ihe.gazelle.evs.DownloadPart']}"
                                       onclick="jq162('#downloadPopup#{node.data.id}').modal('show');">
                                        <s:span title="#{messages['net.ihe.gazelle.evs.DownloadPart']}" styleClass="gzl-icon-download"/>
                                    </a>

                                    <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                                        <ui:param name="popup_id" value="downloadPopup#{node.data.id}"/>
                                        <ui:param name="bodyStyleClass" value="bg-warning"/>
                                        <ui:define name="popup_title">
                                            <s:span styleClass="gzl-icon-exclamation-triangle"/>
                                            <h:outputText value="#{messages['net.ihe.gazelle.mca.DownloadAnalysisSubpart']}"/>
                                        </ui:define>

                                        <p>#{messages['net.ihe.gazelle.mca.YouAreAboutToDownloadTheContentOfASubpartFromThe']}</p>
                                        <p>#{messages['net.ihe.gazelle.mca.NamespacesFromPreviousPartsMayBeReportedBeforeTh']}</p>
                                        <p>#{messages['net.ihe.gazelle.mca.DoYouWantToDownloadTheOriginalContentOrTheAdjust']}</p>

                                        <ui:define name="popup_footer">
                                            <h:commandButton value="#{messages['net.ihe.gazelle.mca.DownloadOriginalContent']}"
                                                             action="#{analysisBeanGui.downloadFile(node.data, false)}"
                                                             oncomplete="jq162('#downloadPopup').modal('hide');"
                                                             styleClass="gzl-btn-blue"/>
                                            <h:commandButton value="#{messages['net.ihe.gazelle.mca.DownloadAdjustedContent']}"
                                                             action="#{analysisBeanGui.downloadFile(node.data, true)}"
                                                             styleClass="gzl-btn-blue"
                                                             oncomplete="jq162('#downloadPopup').modal('hide');"/>
                                        </ui:define>
                                    </ui:decorate>
                                </s:div>

                            </rich:treeNode>
                        </rich:tree>
                    </a4j:region>
                </div>
                <s:div id="#{analysisBeanGui.id}PanelPartArea" style="max-width: 80%">
                    <a4j:region>
                        <div class="split-panel horizontal">
                            <div class="col-md-12">
                                <div>
                                    <s:div id="edit-mode" rendered="#{analysisBeanGui.editModeEnabled}">
                                        <s:decorate template="/layout/form/_checkbox.xhtml" rendered="#{analysisBeanGui.isDisplayedPartXml()}">
                                            <ui:param name="id" value="cb5"/>
                                            <ui:define name="label"><h:outputText value="#{messages['net.ihe.gazelle.mca.EditContent']}"/></ui:define>
                                            <h:selectBooleanCheckbox id="cb5" value="#{analysisBeanGui.editMessageInGui}">
                                                <a4j:ajax event="change" render="#{analysisBeanGui.id}PartView"/>
                                            </h:selectBooleanCheckbox>
                                        </s:decorate>
                                    </s:div>
                                    <s:div id="#{analysisBeanGui.id}PartView">
                                        <s:div id="#{analysisBeanGui.id}NamespaceMessages">
                                            <s:div id="#{analysisBeanGui.id}NamespacesActuallyAdded" rendered="#{analysisBeanGui.namespacesActuallyAdded}">
                                                <s:span styleClass="gzl-icon-info-circle"/>
                                                <h:outputText value="#{messages['net.ihe.gazelle.mca.NamespacesHaveBeenReportedFromPreviousXMLSubpart']}"/>
                                            </s:div>
                                            <s:div id="#{analysisBeanGui.id}NoNamespacesAdded" rendered="#{!analysisBeanGui.namespacesActuallyAdded and analysisBeanGui.showAddedNameSpacesInGui}">
                                                <s:span styleClass="gzl-icon-info-circle"/>
                                                <h:outputText value="#{messages['net.ihe.gazelle.mca.NoNamespacesWereFoundMissingThePartWillBeSendToT']}"/>
                                            </s:div>
                                        </s:div>

                                        <s:div id="#{analysisBeanGui.id}EditMessageMode" rendered="#{analysisBeanGui.editMessageInGui}">
                                            <s:div id="#{analysisBeanGui.id}ButtDiv">
                                                    <a4j:commandButton id="analyse-modified-part" styleClass="gzl-btn-blue" style="margin-bottom: 10px;"
                                                                       rendered="#{analysisBeanGui.selectedMessagePartEdited}"
                                                                       execute="resultFormTokenId"
                                                                       value="#{messages['net.ihe.gazelle.mca.AnalyzeThisEditedPart']}"
                                                                       actionListener="#{analysisBeanGui.executeOnEditedPart()}" />
                                                    <rich:tooltip value="#{messages['net.ihe.gazelle.mca.AnalyzeThisEditedPart']}" target="analyse-modified-part"/>
                                            </s:div>

                                            <h:inputTextarea id="#{analysisBeanGui.id}Messagearea3" readonly="false"
                                                             style="width: 99%; height: 95%; resize: none; "
                                                             styleClass="#{(!analysisBeanGui.isSelectedMessagePartEdited() and !analysisBeanGui.showAddedNameSpacesInGui)?'xml-indented ':''}
                                                         #{(analysisBeanGui.isSelectedMessagePartEdited() and analysisBeanGui.showAddedNameSpacesInGui)?'xml-indented-modified ':''}
                                                         #{(analysisBeanGui.isSelectedMessagePartEdited() and !analysisBeanGui.indentMessageInGui)?'xml-modified ':''}"
                                                             value="#{analysisBeanGui.editedMessagePart}"
                                                             rows="20" maxlength="2048">
                                                <a4j:ajax event="keyup" render="#{analysisBeanGui.id}ButtDiv"
                                                          listener="#{analysisBeanGui.setSelectedMessagePartEdited(true)}"/>
                                            </h:inputTextarea>
                                        </s:div>
                                        <s:div id="#{analysisBeanGui.id}DisplayMessageMode" rendered="#{!analysisBeanGui.editMessageInGui}">
                                            <ui:decorate template="/common/_documentRenderersTabs.xhtml">
                                                <ui:param name="document" value="#{analysisBeanGui.presenter.document}"/>
                                                <ui:param name="renderers" value="#{analysisBeanGui.presenter.renderers}"/>
                                                <ui:param name="activeItem" value="#{analysisBeanGui.presenter.activeRenderer}"/>
                                                <ui:param name="options" value="caption: #{messages['net.ihe.gazelle.document.prettified-content']}"/>
                                                <ui:param name="documentViewerStyle" value="document-long-viewer"/>
                                            </ui:decorate>
                                        </s:div>
                                    </s:div>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <h:inputTextarea id="#{analysisBeanGui.id}LogArea" readonly="true"
                                                 styleClass="greyed-logs"
                                                 value="#{analysisBeanGui.getMessagePartLog()}"
                                                 rendered="#{analysisBeanGui.showLogArea}"
                                                 rows="20" maxlength="2048">
                                </h:inputTextarea>
                            </div>

                        </div>
                    </a4j:region>
                </s:div>
            </div>
        </ui:decorate>
    </s:div>
</ui:composition>
